﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace contabancaria
{
    class Program
    {

        public class Conta
        {
            public int nro_conta { get; set; }
            public double saldo { get; set; }

            public void deposito()
            {
                Console.Write("Qual valor a ser depositado na conta {0}: ", this.nro_conta);
                this.saldo += Convert.ToDouble(Console.ReadLine());

                /*
                 string valordeposito;
                 Console.Write("Qual valor a ser depositado na conta {0}", this.nro_conta);
                 valordeposito = Console.ReadLine();
                 this.saldo = this.saldo + Convert.ToDouble(valordeposito);
                */
            }

            public virtual void saque()
            {
                double vlrsaque;
                Console.Write("Qual valor a ser sacado na conta {0}: ", this.nro_conta);
                vlrsaque = Convert.ToDouble(Console.ReadLine());
                if (vlrsaque <= this.saldo)
                {
                    this.saldo -= vlrsaque;
                    Console.WriteLine("O novo saldo da conta {0} e R$ {1}", this.nro_conta, this.saldo);
                }
                else
                {
                    Console.WriteLine("O saldo da conta {0} é insuficiente para sacar R$ {1}", this.nro_conta, vlrsaque);
                }
            }

            public void versaldo()
            {
                Console.WriteLine("O saldo da conta {0} é R$ {1}", this.nro_conta, this.saldo);
            }

            public Conta()
            {
                Console.Write("Qual o número da conta? ");
                this.nro_conta = Convert.ToInt32(Console.ReadLine());
                this.saldo = 0;

            }

         }

        public class Conta_Especial : Conta
        {
            public double limite { get; set; }


            public Conta_Especial()
            {
                Console.Write("Qual o valor do limite da conta? ");
                this.limite = Convert.ToDouble(Console.ReadLine());
                this.saldo = 0;
            }

            public override void saque()
            {
                double vlrsaque;
                Console.Write("Qual valor a ser sacado na conta {0}: ", this.nro_conta);
                vlrsaque = Convert.ToDouble(Console.ReadLine());
                if (vlrsaque <= this.saldo+this.limite)
                {
                    this.saldo -= vlrsaque;
                    Console.WriteLine("O novo saldo da conta {0} e R$ {1}", this.nro_conta, this.saldo);
                }
                else
                {
                    Console.WriteLine("O saldo da conta {0} mais o limite de {2} é insuficiente para sacar R$ {1}", this.nro_conta, vlrsaque, this.limite);
                }  
            }
        }
        
        static void Main()
        {
            //Conta conta1 = new Conta();
            Conta_Especial conta2 = new Conta_Especial(); // poderia ser assim: Conta conta3 = new Conta_Especial();

            string opt="";
            do
            {
                Console.Clear();
                Console.WriteLine("Gerenciamento de conta especial!");
                Console.WriteLine("\n\nMenu de opções:\n\n\t1 - Depositar\n\t2 - Sacar\n\t3 - Ver saldo\n\t4 - Sair\n\n");
                Console.Write("Escolha uma opção: ");
                opt = Console.ReadLine();
                switch(opt){
                    case "1":
                        conta2.deposito();
                        break;
                    case "2":
                        conta2.saque();
                        Console.ReadKey();
                        break;
                    case "3":
                        conta2.versaldo();
                        Console.ReadKey();
                        break;
                    case"4":
                        break;
                    default:
                        Console.WriteLine("Opção Inválida");
                        Console.ReadKey();
                        break;
                }

                
            } while(opt != "4");

        }
    }
}
